<?php
/*
 * Our model file.
 *
 * PHP version 5
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the Affero General Public License as published by Affero Inc.,
 * either version 1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful to the Free
 * Software community, but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the Affero
 * General Public License for more details.
 * 
 * You should have received a copy of the Affero General Public License with this
 * software in the ./AfferoGPL file; if not, write to Affero Inc., 510 Third Street,
 * Suite 225, San Francisco, CA 94107, USA
 *
 * @category   Model Class
 * @author     Klaus Weiss <klaus.weiss@nanet.at>
 * @copyright  2007 GNU Herds Free Software Association
 * @license    http://www.affero.org/oagpl.html Affero GPL
 * @version    CVS: $Id:$
 * @since      File available since version 1.5
 */

if(!defined('VISIBLE')) exit();

//require_once(ROOT.'/core/model/'.DB_TYPE.'.class.php');

require_once(ROOT.DS.'..'.DS.'..'.DS.'core'.DS.'model'.DS.DB_TYPE.'.class.php');

define('VALID_NOT_EMPTY', '/.+/');
define('VALID_NUMBER', '/^[0-9]+$/');
define('VALID_EMAIL', '/\\A(?:^([a-z0-9][a-z0-9_\\-\\.\\+]*)@([a-z0-9][a-z0-9\\.\\-]{0,63}\\.(com|org|net|biz|info|name|net|pro|aero|coop|museum|[a-z]{2,4}))$)\\z/i');
define('VALID_YEAR', '/^[12][0-9]{3}$/');

class Model
{
  public $name = null;

  public $validate = null;

  private $db = null;
  
  public $data = array();


  public function __construct()
  {
    /*
    if($this->name == null)
      {
	$this->name = get_class($this);
      }

    $this->db = new DB();
    */
  }

  public function __call($method, $params)
  {
    /* 
     * If the called method starts with set/get
     * we handle it as a SQL Query.
     */
    if(preg_match('/^set/', $method))
      {
	list(,$field) = split('set', $method);
	$this->_set($field, $params);
      }
    else if(preg_match('/^get/', $method))
      {
	list(,$field) = split('get', $method);
	$this->_get($field, $params);
      }
  }


  private function _set($field, $params)
  {
    /*
     * params[0] = required new field value
     * params[1] = optional WHERE condition
     * params[2] = optional Model name
     */
    
    if($params[2] != null and !empty($params[2]))
      {
	$table = $params[2];
      }
    else
      {
	$table = $this->name;
      }

    $sql = 'UPDATE '.DB_PREFIX.$table.' SET '.$field.' = \''.$params[0].'\'';

    if($params[1] != null and !empty($params[1]))
      {
	$sql .= ' '.$params[1];
      }

    if(DB_DEBUG)
      {
	show_debug_message('DB Debug', $sql);
      }
  }


  private function _get($field, $params)
  {
    /*
     * params[0] = optional WHERE condition
     * params[1] = optional Model name
     */

    if($params[1] != null and !empty($params[1]))
      {
	$table = $params[1];
      }
    else
      {
	$table = $this->name;
      }

    $sql = 'SELECT '.$field.' FROM '.DB_PREFIX.$table;

    if($params[0] != null and !empty($params[0]))
      {
	$sql .= ' '.$params[0];
      }

    if(DB_DEBUG)
      {
	show_debug_message('DB Debug', $sql);
      }
    
  }

  
  public function validates()
  {
    if($this->validate != null)
      {
	foreach($this->data as $k => $v)
	  {
	    if(array_key_exists())
	      {
		
	      }
	  }
      }
  }

  
  public function query($sql)
  {
    if(get_magic_quotes_gpc() == false)
      {
	$sql = addslashes($sql);
      }

    $this->db->query($sql);
  }

  /*
  public function loadData($data = null)
  {
    if($data == null)
      {
	foreach($_GET as $k => $v)
	  {
	    if(get_magic_quotes_gpc() == false)
	      {
		$this->data['GET'][$k] = addslashes($v);
	      }
	    else
	      {
		$this->data['GET'][$k] = $v;
	      }
	  }
	
	foreach($_POST as $k => $v)
	  {
	    if(get_magic_quotes_gpc() == false)
	      {
		$this->data['POST'][$k] = addslashes($v);
	      }
	    else
	      {
		$this->data['POST'][$k] = $v;
	      }
	  }	
      }
    else
      {
	$this->data = $data;
      }
  }
  */
}


?>