<?php
/*
 * Our index file.
 *
 * PHP version 5
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the Affero General Public License as published by Affero Inc.,
 * either version 1 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful to the Free
 * Software community, but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the Affero
 * General Public License for more details.
 * 
 * You should have received a copy of the Affero General Public License with this
 * software in the ./AfferoGPL file; if not, write to Affero Inc., 510 Third Street,
 * Suite 225, San Francisco, CA 94107, USA
 *
 * @category   Public Controller
 * @author     Klaus Weiss <klaus.weiss@nanet.at>
 * @copyright  2007 GNU Herds Free Software Association
 * @license    http://www.affero.org/oagpl.html Affero GPL
 * @version    CVS: $Id:$
 * @since      File available since version 1.5
 */

define('VISIBLE', true);

define('ROOT', dirname(__FILE__));
define('DS', DIRECTORY_SEPARATOR);

require_once(ROOT.DS.'..'.DS.'..'.DS.'include'.DS.'dep.inc.php');
require_once(ROOT.DS.'..'.DS.'..'.DS.'core'.DS.'controller.class.php');

if(SITE_MOD_REWRITE)
{
  if(isset($_GET['cntr']) and !empty($_GET['cntr']))
    {
      $cntr_file = ROOT.DS.'..'.DS.'..'.DS.'site'.DS.'controller'.DS.$_GET['cntr'].'.php';
      
      if(file_exists($cntr_file))
	{
	  require_once($cntr_file);
	}
      else
	{
	  show_error_site(ERROR_NO_CONTROLLER);
	}

      $controller = $_GET['cntr'].'Controller';

      if(!class_exists($controller))
	{
	  show_error_site(ERROR_NO_CONTROLLER);
	}

      $cntr = new $controller();

      if(isset($_GET['action']) and !empty($_GET['action']))
	{
	  if(!method_exists($cntr, $_GET['action']))
	    {
	      show_error_site(ERROR_NO_ACTION);
	    }

	  $action = $_GET['action'];

	  if(isset($_GET['params']) and !empty($_GET['params']))
	    {
	      $array = split(SITE_URL_SEPARATOR, $_GET['params']);

	      $params = array();
	      for($i = 0; $i < count($array); $i += 2)
		{
		  if(!$array[$i+1])
		    continue;

		  $params[$array[$i]] = $array[$i+1];
		}

	      unset($i);
	      unset($array);
	    }	  
	}
      else
	{
	  /* Should we use a standard action? */
	  show_error_site(ERROR_NO_ACTION);
	}
    }
  else
    {
      /* Should we use a standard controller? */
      show_error_site(ERROR_NO_CONTROLLER);
    }
}
else
{
  $array = split(SITE_URL_SEPARATOR, $HTTP_SERVER_VARS['PATH_INFO']);
  
  $controller = $array[1];

  $cntr_file = ROOT.DS.'..'.DS.'..'.DS.'site'.DS.'controller'.DS.$controller.'.php';;

  if(!file_exists($cntr_file))
    {
      show_error_site(ERROR_NO_CONTROLLER);
    }

  require_once($cntr_file);

  $controller = $controller.'Controller';

  if(!class_exists($controller))
    {
      show_error_site(ERROR_NO_CONTROLLER);
    }

  $cntr = new $controller;

  $action = $array[2];

  if(!method_exists($cntr, $action))
    {
      show_error_site(ERROR_NO_ACTION);
    }
  
  $params = array();
  for($i = 3; $i < count($array); $i += 2)
    {
      if(!$array[$i+1])
	continue;

      $params[$array[$i]] = $array[$i+1];
    }
  
  unset($i);
  unset($array);
}

if(array_key_exists('lang', $params) and !empty($params['lang']))
{
  $k = array_search($params['lang'], Controller::$AVAILABLE_LANGS);

  if($k !== false)
    {
      Controller::_setLanguage($params['lang']);
      $cntr->set('pageLanguage', $params['lang']);
    }
  else
    {
      Controller::_setLanguage(LOCALE_STANDARD);
      $cntr->set('pageLanguage', LOCALE_STANDARD);
    }
}
else
{
  Controller::_setLanguage(Controller::_getPreferredLanguage());
  $cntr->set('pageLanguage', Controller::_getPreferredLanguage());
}


$cntr->data['GET'] = $params;
	      
$cntr->beforeRender();

$cntr->$action();

$cntr->set('pageTitle', $cntr->pageTitle);


$s_cntr = str_replace('Controller', '', $controller);
foreach($params as $k => $v)
{
  $s_params .= $k.'/'.$v;
}

if(SITE_MOD_REWRITE)
{
  $cntr->set('pageCLink', SITE_URL.'/'.$s_cntr.'/'.$action.'/'.$s_params);
}	      
else
{
  $cntr->set('pageCLink', SITE_URL.'/index.php/'.$s_cntr.'/'.$action.'/'.$s_params);
}

$cntr->view->render($action);

$cntr->afterRender();

?>